stages:
- plan
- apply
- destroy

.terraform:
  image:
    name: hashicorp/terraform:1.4.5
    entrypoint: [""]
  variables:
    TF_VAR_student_name: ricardo-tomas
    TF_VAR_location: West Europe
    TF_VAR_environment: $ENV
  before_script:
  - terraform init -backend-config=backend-$ENV.hcl
  tags:
  - findmore
  - outcloud
  parallel:
    matrix:
    - ENV: dev
      ENV_BRANCH: develop
    - ENV: prd
      ENV_BRANCH: main
  rules:
  - if: $CI_COMMIT_BRANCH == $ENV_BRANCH

validate & plan:
  stage: plan
  extends: .terraform
  script:
  - terraform validate
  - terraform plan -out plan.out
  artifacts:
    name: terraform-plan
    paths:
    - plan.out

apply:
  stage: apply
  extends: .terraform
  script:
  - terraform apply plan.out
  when: manual

destroy:
  stage: destroy
  extends: .terraform
  dependencies: []
  script:
  - terraform destroy -auto-approve
  when: manual